Index: irc_send.c
===================================================================
--- irc_send.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
+++ irc_send.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -0,0 +1,398 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2010 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* The IRC-based UI - Sending responses to commands/etc.                */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#include "bitlbee.h"
+
+void irc_send_num( irc_t *irc, int code, char *format, ... )
+{
+	char text[IRC_MAX_LINE];
+	va_list params;
+	
+	va_start( params, format );
+	g_vsnprintf( text, IRC_MAX_LINE, format, params );
+	va_end( params );
+	
+	irc_write( irc, ":%s %03d %s %s", irc->root->host, code, irc->user->nick ? : "*", text );
+}
+
+void irc_send_login( irc_t *irc )
+{
+	irc_send_num( irc,   1, ":Welcome to the BitlBee gateway, %s", irc->user->nick );
+	irc_send_num( irc,   2, ":Host %s is running BitlBee " BITLBEE_VERSION " " ARCH "/" CPU ".", irc->root->host );
+	irc_send_num( irc,   3, ":%s", IRCD_INFO );
+	irc_send_num( irc,   4, "%s %s %s %s", irc->root->host, BITLBEE_VERSION, UMODES UMODES_PRIV, CMODES );
+	irc_send_num( irc,   5, "PREFIX=(ov)@+ CHANTYPES=%s CHANMODES=,,,%s NICKLEN=%d NETWORK=BitlBee "
+	                        "CASEMAPPING=rfc1459 MAXTARGETS=1 WATCH=128 :are supported by this server",
+	                        CTYPES, CMODES, MAX_NICK_LENGTH - 1 );
+	irc_send_motd( irc );
+}
+
+void irc_send_motd( irc_t *irc )
+{
+	int fd;
+	
+	fd = open( global.conf->motdfile, O_RDONLY );
+	if( fd == -1 )
+	{
+		irc_send_num( irc, 422, ":We don't need MOTDs." );
+	}
+	else
+	{
+		char linebuf[80];	/* Max. line length for MOTD's is 79 chars. It's what most IRC networks seem to do. */
+		char *add, max;
+		int len;
+		
+		linebuf[79] = len = 0;
+		max = sizeof( linebuf ) - 1;
+		
+		irc_send_num( irc, 375, ":- %s Message Of The Day - ", irc->root->host );
+		while( read( fd, linebuf + len, 1 ) == 1 )
+		{
+			if( linebuf[len] == '\n' || len == max )
+			{
+				linebuf[len] = 0;
+				irc_send_num( irc, 372, ":- %s", linebuf );
+				len = 0;
+			}
+			else if( linebuf[len] == '%' )
+			{
+				read( fd, linebuf + len, 1 );
+				if( linebuf[len] == 'h' )
+					add = irc->root->host;
+				else if( linebuf[len] == 'v' )
+					add = BITLBEE_VERSION;
+				else if( linebuf[len] == 'n' )
+					add = irc->user->nick;
+				else
+					add = "%";
+				
+				strncpy( linebuf + len, add, max - len );
+				while( linebuf[++len] );
+			}
+			else if( len < max )
+			{
+				len ++;
+			}
+		}
+		irc_send_num( irc, 376, ":End of MOTD" );
+		close( fd );
+	}
+}
+
+void irc_usermsg( irc_t *irc, char *format, ... )
+{
+	irc_channel_t *ic = NULL;
+	irc_user_t *iu = irc->root;
+	char text[1024];
+	va_list params;
+	char *dst;
+	
+	va_start( params, format );
+	g_vsnprintf( text, sizeof( text ), format, params );
+	va_end( params );
+	
+	/* Too similar to bee_irc_user_msg()... */
+	if( iu->last_channel )
+	{
+		if( iu->last_channel->flags & IRC_CHANNEL_JOINED )
+			ic = iu->last_channel;
+		else if( irc->default_channel->flags & IRC_CHANNEL_JOINED )
+			ic = irc->default_channel;
+	}
+	
+	if( ic )
+		dst = ic->name;
+	else
+		dst = irc->user->nick;
+	
+	irc_send_msg( irc->root, "PRIVMSG", dst, text, NULL );
+}
+
+void irc_send_join( irc_channel_t *ic, irc_user_t *iu )
+{
+	irc_t *irc = ic->irc;
+	
+	irc_write( irc, ":%s!%s@%s JOIN :%s", iu->nick, iu->user, iu->host, ic->name );
+	
+	if( iu == irc->user )
+	{
+		irc_write( irc, ":%s MODE %s +%s", irc->root->host, ic->name, ic->mode );
+		irc_send_names( ic );
+		if( ic->topic && *ic->topic )
+			irc_send_topic( ic, FALSE );
+	}
+}
+
+void irc_send_part( irc_channel_t *ic, irc_user_t *iu, const char *reason )
+{
+	irc_write( ic->irc, ":%s!%s@%s PART %s :%s", iu->nick, iu->user, iu->host, ic->name, reason ? : "" );
+}
+
+void irc_send_quit( irc_user_t *iu, const char *reason )
+{
+	irc_write( iu->irc, ":%s!%s@%s QUIT :%s", iu->nick, iu->user, iu->host, reason ? : "" );
+}
+
+void irc_send_kick( irc_channel_t *ic, irc_user_t *iu, irc_user_t *kicker, const char *reason )
+{
+	irc_write( ic->irc, ":%s!%s@%s KICK %s %s :%s", kicker->nick, kicker->user,
+	           kicker->host, ic->name, iu->nick, reason ? : "" );
+}
+
+void irc_send_names( irc_channel_t *ic )
+{
+	GSList *l;
+	char namelist[385] = "";
+	
+	/* RFCs say there is no error reply allowed on NAMES, so when the
+	   channel is invalid, just give an empty reply. */
+	for( l = ic->users; l; l = l->next )
+	{
+		irc_channel_user_t *icu = l->data;
+		irc_user_t *iu = icu->iu;
+		
+		if( strlen( namelist ) + strlen( iu->nick ) > sizeof( namelist ) - 4 )
+		{
+			irc_send_num( ic->irc, 353, "= %s :%s", ic->name, namelist );
+			*namelist = 0;
+		}
+		
+		if( icu->flags & IRC_CHANNEL_USER_OP )
+			strcat( namelist, "@" );
+		else if( icu->flags & IRC_CHANNEL_USER_HALFOP )
+			strcat( namelist, "%" );
+		else if( icu->flags & IRC_CHANNEL_USER_VOICE )
+			strcat( namelist, "+" );
+		
+		strcat( namelist, iu->nick );
+		strcat( namelist, " " );
+	}
+	
+	if( *namelist )
+		irc_send_num( ic->irc, 353, "= %s :%s", ic->name, namelist );
+	
+	irc_send_num( ic->irc, 366, "%s :End of /NAMES list", ic->name );
+}
+
+void irc_send_topic( irc_channel_t *ic, gboolean topic_change )
+{
+	if( topic_change && ic->topic_who )
+	{
+		irc_write( ic->irc, ":%s TOPIC %s :%s", ic->topic_who, 
+		           ic->name, ic->topic && *ic->topic ? ic->topic : "" );
+	}
+	else if( ic->topic )
+	{
+		irc_send_num( ic->irc, 332, "%s :%s", ic->name, ic->topic );
+		if( ic->topic_who )
+			irc_send_num( ic->irc, 333, "%s %s %d",
+			              ic->name, ic->topic_who, (int) ic->topic_time );
+	}
+	else
+		irc_send_num( ic->irc, 331, "%s :No topic for this channel", ic->name );
+}
+
+void irc_send_whois( irc_user_t *iu )
+{
+	irc_t *irc = iu->irc;
+	
+	irc_send_num( irc, 311, "%s %s %s * :%s",
+	              iu->nick, iu->user, iu->host, iu->fullname );
+	
+	if( iu->bu )
+	{
+		bee_user_t *bu = iu->bu;
+		
+		irc_send_num( irc, 312, "%s %s.%s :%s network", iu->nick, bu->ic->acc->user,
+		           bu->ic->acc->server && *bu->ic->acc->server ? bu->ic->acc->server : "",
+		           bu->ic->acc->prpl->name );
+		
+		if( ( bu->status && *bu->status ) ||
+		    ( bu->status_msg && *bu->status_msg ) )
+		{
+			int num = bu->flags & BEE_USER_AWAY ? 301 : 320;
+			
+			if( bu->status && bu->status_msg )
+				irc_send_num( irc, num, "%s :%s (%s)", iu->nick, bu->status, bu->status_msg );
+			else
+				irc_send_num( irc, num, "%s :%s", iu->nick, bu->status ? : bu->status_msg );
+		}
+		else if( !( bu->flags & BEE_USER_ONLINE ) )
+		{
+			irc_send_num( irc, 301, "%s :%s", iu->nick, "User is offline" );
+		}
+		
+		if( bu->idle_time || bu->login_time )
+		{
+			irc_send_num( irc, 317, "%s %d %d :seconds idle, signon time",
+			              iu->nick,
+			              bu->idle_time ? (int) ( time( NULL ) - bu->idle_time ) : 0,
+			              (int) bu->login_time );
+		}
+	}
+	else
+	{
+		irc_send_num( irc, 312, "%s %s :%s", iu->nick, irc->root->host, IRCD_INFO );
+	}
+	
+	irc_send_num( irc, 318, "%s :End of /WHOIS list", iu->nick );
+}
+
+void irc_send_who( irc_t *irc, GSList *l, const char *channel )
+{
+	gboolean is_channel = strcmp( channel, "**" ) != 0;
+	
+	while( l )
+	{
+		irc_user_t *iu = l->data;
+		if( is_channel )
+			iu = ((irc_channel_user_t*)iu)->iu;
+		/* TODO(wilmer): Restore away/channel information here */
+		irc_send_num( irc, 352, "%s %s %s %s %s %c :0 %s",
+		              channel ? : "*", iu->user, iu->host, irc->root->host,
+		              iu->nick, iu->flags & IRC_USER_AWAY ? 'G' : 'H',
+		              iu->fullname );
+		l = l->next;
+	}
+	
+	irc_send_num( irc, 315, "%s :End of /WHO list", channel );
+}
+
+void irc_send_msg( irc_user_t *iu, const char *type, const char *dst, const char *msg, const char *prefix )
+{
+	char last = 0;
+	const char *s = msg, *line = msg;
+	char raw_msg[strlen(msg)+1024];
+	
+	while( !last )
+	{
+		if( *s == '\r' && *(s+1) == '\n' )
+			s++;
+		if( *s == '\n' )
+		{
+			last = s[1] == 0;
+		}
+		else
+		{
+			last = s[0] == 0;
+		}
+		if( *s == 0 || *s == '\n' )
+		{
+			if( g_strncasecmp( line, "/me ", 4 ) == 0 && ( !prefix || !*prefix ) &&
+			    g_strcasecmp( type, "PRIVMSG" ) == 0 )
+			{
+				strcpy( raw_msg, "\001ACTION " );
+				strncat( raw_msg, line + 4, s - line - 4 );
+				strcat( raw_msg, "\001" );
+				irc_send_msg_raw( iu, type, dst, raw_msg );
+			}
+			else
+			{
+				*raw_msg = '\0';
+				if( prefix && *prefix )
+					strcpy( raw_msg, prefix );
+				strncat( raw_msg, line, s - line );
+				irc_send_msg_raw( iu, type, dst, raw_msg );
+			}
+			line = s + 1;
+		}
+		s ++;
+	}
+}
+
+void irc_send_msg_raw( irc_user_t *iu, const char *type, const char *dst, const char *msg )
+{
+	irc_write( iu->irc, ":%s!%s@%s %s %s :%s",
+	           iu->nick, iu->user, iu->host, type, dst, msg );
+}
+
+void irc_send_msg_f( irc_user_t *iu, const char *type, const char *dst, const char *format, ... )
+{
+	char text[IRC_MAX_LINE];
+	va_list params;
+	
+	va_start( params, format );
+	g_vsnprintf( text, IRC_MAX_LINE, format, params );
+	va_end( params );
+	
+	irc_write( iu->irc, ":%s!%s@%s %s %s :%s",
+	           iu->nick, iu->user, iu->host, type, dst, text );
+}
+
+void irc_send_nick( irc_user_t *iu, const char *new )
+{
+	irc_write( iu->irc, ":%s!%s@%s NICK %s",
+	           iu->nick, iu->user, iu->host, new );
+}
+
+/* Send an update of a user's mode inside a channel, compared to what it was. */
+void irc_send_channel_user_mode_diff( irc_channel_t *ic, irc_user_t *iu,
+	irc_channel_user_flags_t old, irc_channel_user_flags_t new )
+{
+	char changes[3*(5+strlen(iu->nick))];
+	char from[strlen(ic->irc->root->nick)+strlen(ic->irc->root->user)+strlen(ic->irc->root->host)+3];
+	int n;
+	
+	*changes = '\0'; n = 0;
+	if( ( old & IRC_CHANNEL_USER_OP ) != ( new & IRC_CHANNEL_USER_OP ) )
+	{
+		n ++;
+		if( new & IRC_CHANNEL_USER_OP )
+			strcat( changes, "+o" );
+		else
+			strcat( changes, "-o" );
+	}
+	if( ( old & IRC_CHANNEL_USER_HALFOP ) != ( new & IRC_CHANNEL_USER_HALFOP ) )
+	{
+		n ++;
+		if( new & IRC_CHANNEL_USER_HALFOP )
+			strcat( changes, "+h" );
+		else
+			strcat( changes, "-h" );
+	}
+	if( ( old & IRC_CHANNEL_USER_VOICE ) != ( new & IRC_CHANNEL_USER_VOICE ) )
+	{
+		n ++;
+		if( new & IRC_CHANNEL_USER_VOICE )
+			strcat( changes, "+v" );
+		else
+			strcat( changes, "-v" );
+	}
+	while( n )
+	{
+		strcat( changes, " " );
+		strcat( changes, iu->nick );
+		n --;
+	}
+	
+	if( set_getbool( &ic->irc->b->set, "simulate_netsplit" ) )
+		g_snprintf( from, sizeof( from ), "%s", ic->irc->root->host );
+	else
+		g_snprintf( from, sizeof( from ), "%s!%s@%s", ic->irc->root->nick,
+		            ic->irc->root->user, ic->irc->root->host );
+	
+	if( *changes )
+		irc_write( ic->irc, ":%s MODE %s %s", from, ic->name, changes );
+}
Index: irc_user.c
===================================================================
--- irc_user.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
+++ irc_user.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -0,0 +1,261 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* Stuff to handle, save and search IRC buddies                         */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#include "bitlbee.h"
+#include "ipc.h"
+
+irc_user_t *irc_user_new( irc_t *irc, const char *nick )
+{
+	irc_user_t *iu = g_new0( irc_user_t, 1 );
+	
+	iu->irc = irc;
+	iu->nick = g_strdup( nick );
+	iu->user = iu->host = iu->fullname = iu->nick;
+	
+	if( set_getbool( &irc->b->set, "private" ) )
+		iu->last_channel = NULL;
+	else
+		iu->last_channel = irc->default_channel;
+	
+	iu->key = g_strdup( nick );
+	nick_lc( iu->key );
+	/* Using the hash table for speed and irc->users for easy iteration
+	   through the list (since the GLib API doesn't have anything sane
+	   for that.) */
+	g_hash_table_insert( irc->nick_user_hash, iu->key, iu );
+	irc->users = g_slist_insert_sorted( irc->users, iu, irc_user_cmp );
+	
+	return iu;
+}
+
+int irc_user_free( irc_t *irc, irc_user_t *iu )
+{
+	static struct im_connection *last_ic;
+	static char *msg;
+	
+	if( !iu )
+		return 0;
+	
+	if( iu->bu &&
+	    ( iu->bu->ic->flags & OPT_LOGGING_OUT ) &&
+	    iu->bu->ic != last_ic )
+	{
+		char host_prefix[] = "bitlbee.";
+		char *s;
+		
+		/* Irssi recognises netsplits by quitmsgs with two
+		   hostnames, where a hostname is a "word" with one
+		   of more dots. Mangle no-dot hostnames a bit. */
+		if( strchr( irc->root->host, '.' ) )
+			*host_prefix = '\0';
+		
+		last_ic = iu->bu->ic;
+		g_free( msg );
+		if( !set_getbool( &irc->b->set, "simulate_netsplit" ) )
+			msg = g_strdup( "Account off-line" );
+		else if( ( s = strchr( iu->bu->ic->acc->user, '@' ) ) )
+			msg = g_strdup_printf( "%s%s %s", host_prefix,
+			        irc->root->host, s + 1 );
+		else
+			msg = g_strdup_printf( "%s%s %s.%s",
+				host_prefix, irc->root->host,
+				iu->bu->ic->acc->prpl->name, irc->root->host );
+	}
+	else if( !iu->bu || !( iu->bu->ic->flags & OPT_LOGGING_OUT ) )
+	{
+		g_free( msg );
+		msg = g_strdup( "Removed" );
+		last_ic = NULL;
+	}
+	irc_user_quit( iu, msg );
+	
+	irc->users = g_slist_remove( irc->users, iu );
+	g_hash_table_remove( irc->nick_user_hash, iu->key );
+	
+	g_free( iu->nick );
+	if( iu->nick != iu->user ) g_free( iu->user );
+	if( iu->nick != iu->host ) g_free( iu->host );
+	if( iu->nick != iu->fullname ) g_free( iu->fullname );
+	g_free( iu->pastebuf );
+	if( iu->pastebuf_timer ) b_event_remove( iu->pastebuf_timer );
+	g_free( iu->key );
+	g_free( iu );
+	
+	return 1;
+}
+
+irc_user_t *irc_user_by_name( irc_t *irc, const char *nick )
+{
+	char key[strlen(nick)+1];
+	
+	strcpy( key, nick );
+	if( nick_lc( key ) )
+		return g_hash_table_lookup( irc->nick_user_hash, key );
+	else
+		return NULL;
+}
+
+int irc_user_set_nick( irc_user_t *iu, const char *new )
+{
+	irc_t *irc = iu->irc;
+	irc_user_t *new_iu;
+	char key[strlen(new)+1];
+	GSList *cl;
+	
+	strcpy( key, new );
+	if( iu == NULL || !nick_lc( key ) ||
+	    ( ( new_iu = irc_user_by_name( irc, new ) ) && new_iu != iu ) )
+		return 0;
+	
+	for( cl = irc->channels; cl; cl = cl->next )
+	{
+		irc_channel_t *ic = cl->data;
+		
+		/* Send a NICK update if we're renaming our user, or someone
+		   who's in the same channel like our user. */
+		if( iu == irc->user ||
+		    ( ( ic->flags & IRC_CHANNEL_JOINED ) &&
+		      irc_channel_has_user( ic, iu ) ) )
+		{
+			irc_send_nick( iu, new );
+			break;
+		}
+	}
+	
+	irc->users = g_slist_remove( irc->users, iu );
+	g_hash_table_remove( irc->nick_user_hash, iu->key );
+	
+	if( iu->nick == iu->user ) iu->user = NULL;
+	if( iu->nick == iu->host ) iu->host = NULL;
+	if( iu->nick == iu->fullname ) iu->fullname = NULL;
+	g_free( iu->nick );
+	iu->nick = g_strdup( new );
+	if( iu->user == NULL ) iu->user = g_strdup( iu->nick );
+	if( iu->host == NULL ) iu->host = g_strdup( iu->nick );
+	if( iu->fullname == NULL ) iu->fullname = g_strdup( iu->nick );
+	
+	iu->key = g_strdup( key );
+	g_hash_table_insert( irc->nick_user_hash, iu->key, iu );
+	irc->users = g_slist_insert_sorted( irc->users, iu, irc_user_cmp );
+	
+	if( iu == irc->user )
+		ipc_to_master_str( "NICK :%s\r\n", new );
+	
+	return 1;
+}
+
+gint irc_user_cmp( gconstpointer a_, gconstpointer b_ )
+{
+	const irc_user_t *a = a_, *b = b_;
+	
+	return strcmp( a->key, b->key );
+}
+
+const char *irc_user_get_away( irc_user_t *iu )
+{
+	irc_t *irc = iu->irc;
+	bee_user_t *bu = iu->bu;
+	
+	if( iu == irc->user )
+		return set_getstr( &irc->b->set, "away" );
+	else if( bu )
+	{
+		if( !bu->flags & BEE_USER_ONLINE )
+			return "Offline";
+		else if( bu->flags & BEE_USER_AWAY )
+		{
+			if( bu->status_msg )
+			{
+				static char ret[MAX_STRING];
+				g_snprintf( ret, MAX_STRING - 1, "%s (%s)",
+				            bu->status ? : "Away", bu->status_msg );
+				return ret;
+			}
+			else
+				return bu->status ? : "Away";
+		}
+	}
+	
+	return NULL;
+}
+
+void irc_user_quit( irc_user_t *iu, const char *msg )
+{
+	GSList *l;
+	gboolean send_quit = FALSE;
+	
+	if( !iu )
+		return;
+	
+	for( l = iu->irc->channels; l; l = l->next )
+		send_quit |= irc_channel_del_user( (irc_channel_t*) l->data, iu, IRC_CDU_SILENT, NULL );
+	
+	if( send_quit )
+		irc_send_quit( iu, msg );
+}
+
+/* User-type dependent functions, for root/NickServ: */
+static gboolean root_privmsg( irc_user_t *iu, const char *msg )
+{
+	char cmd[strlen(msg)+1];
+	
+	strcpy( cmd, msg );
+	root_command_string( iu->irc, cmd );
+	
+	return TRUE;
+}
+
+static gboolean root_ctcp( irc_user_t *iu, char * const *ctcp )
+{
+	if( g_strcasecmp( ctcp[0], "VERSION" ) == 0 )
+	{
+		irc_send_msg_f( iu, "NOTICE", iu->irc->user->nick, "\001%s %s\001",
+		                ctcp[0], "BitlBee " BITLBEE_VERSION " " ARCH "/" CPU );
+	}
+	else if( g_strcasecmp( ctcp[0], "PING" ) == 0 )
+	{
+		irc_send_msg_f( iu, "NOTICE", iu->irc->user->nick, "\001%s %s\001",
+		                ctcp[0], ctcp[1] ? : "" );
+	}
+	
+	return TRUE;
+}
+
+const struct irc_user_funcs irc_user_root_funcs = {
+	root_privmsg,
+	root_ctcp,
+};
+
+/* Echo to yourself: */
+static gboolean self_privmsg( irc_user_t *iu, const char *msg )
+{
+	irc_send_msg( iu, "PRIVMSG", iu->nick, msg, NULL );
+	
+	return TRUE;
+}
+
+const struct irc_user_funcs irc_user_self_funcs = {
+	self_privmsg,
+};
Index: irc_util.c
===================================================================
--- irc_util.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
+++ irc_util.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -0,0 +1,115 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2010 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* Some stuff that doesn't belong anywhere else.                        */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#include "bitlbee.h"
+
+char *set_eval_timezone( set_t *set, char *value )
+{
+	char *s;
+	
+	if( strcmp( value, "local" ) == 0 ||
+	    strcmp( value, "gmt" ) == 0 || strcmp( value, "utc" ) == 0 )
+		return value;
+	
+	/* Otherwise: +/- at the beginning optional, then one or more numbers,
+	   possibly followed by a colon and more numbers. Don't bother bound-
+	   checking them since users are free to shoot themselves in the foot. */
+	s = value;
+	if( *s == '+' || *s == '-' )
+		s ++;
+	
+	/* \d+ */
+	if( !isdigit( *s ) )
+		return SET_INVALID;
+	while( *s && isdigit( *s ) ) s ++;
+	
+	/* EOS? */
+	if( *s == '\0' )
+		return value;
+	
+	/* Otherwise, colon */
+	if( *s != ':' )
+		return SET_INVALID;
+	s ++;
+	
+	/* \d+ */
+	if( !isdigit( *s ) )
+		return SET_INVALID;
+	while( *s && isdigit( *s ) ) s ++;
+	
+	/* EOS */
+	return *s == '\0' ? value : SET_INVALID;
+}
+
+char *irc_format_timestamp( irc_t *irc, time_t msg_ts )
+{
+	time_t now_ts = time( NULL );
+	struct tm now, msg;
+	char *set;
+	
+	/* If the timestamp is <= 0 or less than a minute ago, discard it as
+	   it doesn't seem to add to much useful info and/or might be noise. */
+	if( msg_ts <= 0 || msg_ts > now_ts - 60 )
+		return NULL;
+	
+	set = set_getstr( &irc->b->set, "timezone" );
+	if( strcmp( set, "local" ) == 0 )
+	{
+		localtime_r( &now_ts, &now );
+		localtime_r( &msg_ts, &msg );
+	}
+	else
+	{
+		int hr, min = 0, sign = 60;
+		
+		if( set[0] == '-' )
+		{
+			sign *= -1;
+			set ++;
+		}
+		else if( set[0] == '+' )
+		{
+			set ++;
+		}
+		
+		if( sscanf( set, "%d:%d", &hr, &min ) >= 1 )
+		{
+			msg_ts += sign * ( hr * 60 + min );
+			now_ts += sign * ( hr * 60 + min );
+		}
+		
+		gmtime_r( &now_ts, &now );
+		gmtime_r( &msg_ts, &msg );
+	}
+	
+	if( msg.tm_year == now.tm_year && msg.tm_yday == now.tm_yday )
+		return g_strdup_printf( "\x02[\x02\x02\x02%02d:%02d:%02d\x02]\x02 ",
+		                        msg.tm_hour, msg.tm_min, msg.tm_sec );
+	else
+		return g_strdup_printf( "\x02[\x02\x02\x02%04d-%02d-%02d "
+		                        "%02d:%02d:%02d\x02]\x02 ",
+		                        msg.tm_year + 1900, msg.tm_mon + 1, msg.tm_mday,
+		                        msg.tm_hour, msg.tm_min, msg.tm_sec );
+}
Index: lib/Makefile
===================================================================
--- lib/Makefile	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ lib/Makefile	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -8,9 +8,11 @@
 
 -include ../Makefile.settings
+ifdef SRCDIR
+SRCDIR := $(SRCDIR)lib/
+endif
 
 # [SH] Program variables
-objects = arc.o base64.o $(EVENT_HANDLER) http_client.o ini.o md5.o misc.o proxy.o sha1.o $(SSL_CLIENT) url.o xmltree.o
+objects = arc.o base64.o $(EVENT_HANDLER) ftutil.o http_client.o ini.o md5.o misc.o oauth.o proxy.o sha1.o $(SSL_CLIENT) url.o xmltree.o
 
-CFLAGS += -Wall
 LFLAGS += -r
 
@@ -37,5 +39,5 @@
 $(objects): ../Makefile.settings Makefile
 
-$(objects): %.o: %.c
+$(objects): %.o: $(SRCDIR)%.c
 	@echo '*' Compiling $<
 	@$(CC) -c $(CFLAGS) $< -o $@
Index: lib/events.h
===================================================================
--- lib/events.h	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ lib/events.h	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -48,6 +48,8 @@
    the given callback function. */
 typedef enum {
-	GAIM_INPUT_READ = 1 << 1,
-	GAIM_INPUT_WRITE = 1 << 2
+	B_EV_IO_READ = 1 << 0,
+	B_EV_IO_WRITE = 1 << 1,
+	B_EV_FLAG_FORCE_ONCE = 1 << 16,
+	B_EV_FLAG_FORCE_REPEAT = 1 << 17,
 } b_input_condition;
 typedef gboolean (*b_event_handler)(gpointer data, gint fd, b_input_condition cond);
Index: lib/events_glib.c
===================================================================
--- lib/events_glib.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ lib/events_glib.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -49,4 +49,5 @@
 	b_event_handler function;
 	gpointer data;
+	guint flags;
 } GaimIOClosure;
 
@@ -76,7 +77,7 @@
 
 	if (condition & GAIM_READ_COND)
-		gaim_cond |= GAIM_INPUT_READ;
+		gaim_cond |= B_EV_IO_READ;
 	if (condition & GAIM_WRITE_COND)
-		gaim_cond |= GAIM_INPUT_WRITE;
+		gaim_cond |= B_EV_IO_WRITE;
 	
 	event_debug( "gaim_io_invoke( %d, %d, 0x%x )\n", g_io_channel_unix_get_fd(source), condition, data );
@@ -87,5 +88,10 @@
 		event_debug( "Returned FALSE, cancelling.\n" );
 	
-	return st;
+	if (closure->flags & B_EV_FLAG_FORCE_ONCE)
+		return FALSE;
+	else if (closure->flags & B_EV_FLAG_FORCE_REPEAT)
+		return TRUE;
+	else
+		return st;
 }
 
@@ -105,8 +111,9 @@
 	closure->function = function;
 	closure->data = data;
+	closure->flags = condition;
 	
-	if (condition & GAIM_INPUT_READ)
+	if (condition & B_EV_IO_READ)
 		cond |= GAIM_READ_COND;
-	if (condition & GAIM_INPUT_WRITE)
+	if (condition & B_EV_IO_WRITE)
 		cond |= GAIM_WRITE_COND;
 	
Index: lib/events_libevent.c
===================================================================
--- lib/events_libevent.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ lib/events_libevent.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -60,4 +60,5 @@
 	b_event_handler function;
 	void *data;
+	guint flags;
 };
 
@@ -126,7 +127,7 @@
 	{
 		if( event & EV_READ )
-			cond |= GAIM_INPUT_READ;
+			cond |= B_EV_IO_READ;
 		if( event & EV_WRITE )
-			cond |= GAIM_INPUT_WRITE;
+			cond |= B_EV_IO_WRITE;
 	}
 	
@@ -150,5 +151,5 @@
 		return;
 	}
-	else if( !st )
+	else if( !st && !( b_ev->flags & B_EV_FLAG_FORCE_REPEAT ) )
 	{
 		event_debug( "Handler returned FALSE: " );
@@ -174,6 +175,6 @@
 	event_debug( "b_input_add( %d, %d, 0x%x, 0x%x ) ", fd, condition, function, data );
 	
-	if( ( condition & GAIM_INPUT_READ  && ( b_ev = g_hash_table_lookup( read_hash,  &fd ) ) ) ||
-	    ( condition & GAIM_INPUT_WRITE && ( b_ev = g_hash_table_lookup( write_hash, &fd ) ) ) )
+	if( ( condition & B_EV_IO_READ  && ( b_ev = g_hash_table_lookup( read_hash,  &fd ) ) ) ||
+	    ( condition & B_EV_IO_WRITE && ( b_ev = g_hash_table_lookup( write_hash, &fd ) ) ) )
 	{
 		/* We'll stick with this libevent entry, but give it a new BitlBee id. */
@@ -198,7 +199,7 @@
 		
 		out_cond = EV_PERSIST;
-		if( condition & GAIM_INPUT_READ )
+		if( condition & B_EV_IO_READ )
 			out_cond |= EV_READ;
-		if( condition & GAIM_INPUT_WRITE )
+		if( condition & B_EV_IO_WRITE )
 			out_cond |= EV_WRITE;
 		
@@ -212,4 +213,5 @@
 	}
 	
+	b_ev->flags = condition;
 	g_hash_table_insert( id_hash, &b_ev->id, b_ev );
 	return b_ev->id;
